

function ___$insertStyle(css) {
  if (!css) {
    return;
  }
  if (typeof window === 'undefined') {
    return;
  }

  var style = document.createElement('style');

  style.setAttribute('type', 'text/css');
  style.innerHTML = css;
  document.head.appendChild(style);
  return css;
}

Object.defineProperty(exports, '__esModule', { value: true });

var React = require('react');

/*! *****************************************************************************
Copyright (c) Microsoft Corporation. All rights reserved.
Licensed under the Apache License, Version 2.0 (the "License"); you may not use
this file except in compliance with the License. You may obtain a copy of the
License at http://www.apache.org/licenses/LICENSE-2.0

THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
MERCHANTABLITY OR NON-INFRINGEMENT.

See the Apache Version 2.0 License for specific language governing permissions
and limitations under the License.
***************************************************************************** */

var __assign = function() {
    __assign = Object.assign || function __assign(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};

var Formal = function (_a) {
    var initialValues = _a.initialValues, validationSchema = _a.validationSchema, _b = _a.isInitiallyValid, isInitiallyValid = _b === void 0 ? true : _b, children = _a.children, onSubmit = _a.onSubmit;
    var _c = React.useState(initialValues), formData = _c[0], setFormData = _c[1];
    var _d = React.useState(!isInitiallyValid), shouldValidate = _d[0], setShouldValidate = _d[1];
    var _e = React.useState(null), isValid = _e[0], setIsValid = _e[1];
    var _f = React.useState(false), isSubmitting = _f[0], setIsSubmitting = _f[1];
    var _g = React.useState([]), errors = _g[0], setErrors = _g[1];
    var validateForm = React.useCallback(function () {
        var newErrors = [];
        validationSchema.forEach(function (item) {
            if (item.required && formData[item.field] === "") {
                newErrors.push({
                    field: item.field,
                    message: "This field is required",
                });
            }
        });
        setErrors(newErrors);
    }, [formData, validationSchema]);
    React.useEffect(function () {
        if (formData && shouldValidate) {
            validateForm();
        }
    }, [formData, validateForm, shouldValidate]);
    React.useEffect(function () {
        setIsValid(errors && !!errors.length ? false : true);
    }, [errors]);
    React.useEffect(function () {
        if (isSubmitting && isValid) {
            onSubmit(formData);
        }
        else {
            setIsSubmitting(false);
        }
    }, [isSubmitting, isValid, onSubmit, formData]);
    var handleFormSubmit = function () {
        setShouldValidate(true);
        setIsSubmitting(true);
    };
    var onChangeValues = function (newValue) {
        setFormData(__assign({}, formData, newValue));
    };
    return (React.createElement("form", null, children({
        values: formData,
        onChangeValues: onChangeValues,
        handleFormSubmit: handleFormSubmit,
        isSubmitting: isSubmitting,
        isValid: isValid,
        errors: errors,
    })));
};

exports.default = Formal;
//# sourceMappingURL=index.js.map
